diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
index 42336c355..4829a7b28 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
@@ -5,6 +5,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockFence;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
 public class BlockModelFence<T  extends BlockFence> extends BlockModelStandard<T> {
@@ -73,7 +74,7 @@ public class BlockModelFence<T  extends BlockFence> extends BlockModelStandard<T
     }
 
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha) {
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         if(renderBlocks.useInventoryTint)
         {
             int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java
index f40e58a29..2c249770e 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java
@@ -5,6 +5,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockFenceGate;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
 public class BlockModelFenceGate<T extends BlockFenceGate> extends BlockModelStandard<T>{
@@ -161,7 +162,7 @@ public class BlockModelFenceGate<T extends BlockFenceGate> extends BlockModelSta
     }
 
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha) {
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         if(renderBlocks.useInventoryTint)
         {
             int j = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
index 13376b781..8e5fbf685 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
@@ -8,6 +8,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockFenceThin;
 import net.minecraft.core.util.helper.Direction;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
 public class BlockModelFenceThin<T extends BlockFenceThin> extends BlockModelStandard<T> {
@@ -349,7 +350,7 @@ public class BlockModelFenceThin<T extends BlockFenceThin> extends BlockModelSta
     }
 
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha) {
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         if(renderBlocks.useInventoryTint)
         {
             int j = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
index 623b345f9..2f74fbfb6 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
@@ -46,10 +46,10 @@ public class BlockModelFluid<T extends Block> extends BlockModelStandard<T> {
         final float yOff = 0.001f;
         Material material = block.blockMaterial;
         int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
-        float f7 = func_1224_a(x, y, z, material);
-        float f8 = func_1224_a(x, y, z + 1, material);
-        float f9 = func_1224_a(x + 1, y, z + 1, material);
-        float f10 = func_1224_a(x + 1, y, z, material);
+        float f7 = BlockFluid.getFluidHeight(renderBlocks.blockAccess, x, y, z, material);
+        float f8 = BlockFluid.getFluidHeight(renderBlocks.blockAccess, x, y, z + 1, material);
+        float f9 = BlockFluid.getFluidHeight(renderBlocks.blockAccess, x + 1, y, z + 1, material);
+        float f10 = BlockFluid.getFluidHeight(renderBlocks.blockAccess, x + 1, y, z, material);
         if(renderBlocks.renderAllFaces || renderTop)
         {
             didRender = true;
@@ -75,10 +75,12 @@ public class BlockModelFluid<T extends Block> extends BlockModelStandard<T> {
                 double centerV = texture.getSubIconV(0.5);
                 float cSin = MathHelper.cos(rotation)/2;
                 float sin = MathHelper.sin(rotation)/2;
+
                 double minU = texture.getIconUMin();
                 double maxU = texture.getIconUMax();
                 double minV = texture.getIconVMin();
                 double maxV = texture.getIconVMax();
+
                 tessellator.setColorOpaque_F(sideTop * blockBrightness * r, sideTop * blockBrightness * g, sideTop * blockBrightness * b);
                 tessellator.addVertexWithUV(x,      (float)y + f7,      z,      ((minU - centerU) * sin - (maxV - centerV) * cSin) + centerU, ((maxV - centerV) * sin + (minU - centerU) * cSin) + centerV);
                 tessellator.addVertexWithUV(x,      (float)y + f8,      z + 1,  ((maxU - centerU) * sin - (maxV - centerV) * cSin) + centerU, ((maxV - centerV) * sin + (maxU - centerU) * cSin) + centerV);
@@ -208,40 +210,7 @@ public class BlockModelFluid<T extends Block> extends BlockModelStandard<T> {
         block.maxY = d1;
         return didRender;
     }
-    private float func_1224_a(int i, int j, int k, Material material)
-    {
-        int l = 0;
-        float f = 0.0F;
-        for(int i1 = 0; i1 < 4; i1++)
-        {
-            int j1 = i - (i1 & 1);
-            int l1 = k - (i1 >> 1 & 1);
-            if(renderBlocks.blockAccess.getBlockMaterial(j1, j + 1, l1) == material)
-            {
-                return 1.0F;
-            }
-            Material material1 = renderBlocks.blockAccess.getBlockMaterial(j1, j, l1);
-            if(material1 == material)
-            {
-                int i2 = renderBlocks.blockAccess.getBlockMetadata(j1, j, l1);
-                if(i2 >= 8 || i2 == 0)
-                {
-                    f += BlockFluid.getWaterVolume(i2) * 10F;
-                    l += 10;
-                }
-                f += BlockFluid.getWaterVolume(i2);
-                l++;
-                continue;
-            }
-            if(!material1.isSolid())
-            {
-                f++;
-                l++;
-            }
-        }
 
-        return Math.max(1.0F - f / (float)l, 0.015F);
-    }
     @Override
     public boolean shouldItemRender3d() {
         return false;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java
index 6f6a4cb97..dc0ae1411 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java
@@ -10,6 +10,7 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
 public class BlockModelGrass<T extends Block> extends BlockModelStandard<T> {
@@ -37,7 +38,7 @@ public class BlockModelGrass<T extends Block> extends BlockModelStandard<T> {
         return didRender;
     }
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha) {
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         GL11.glColor4f(brightness, brightness, brightness, alpha);
         float yOffset = 0.5F;
         setBlockBoundsForItemRender();
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
index d7b279161..f6719d342 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
@@ -3,6 +3,7 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
 public class BlockModelLayer<T extends Block> extends BlockModelStandard<T> {
@@ -11,9 +12,9 @@ public class BlockModelLayer<T extends Block> extends BlockModelStandard<T> {
         withCustomItemBounds(0.0f, 0.0f, 0.0f, 1.0f, 2 / 16F, 1.0f);
     }
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha) {
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         GL11.glTranslatef(0, 0.25f, 0);
-        super.renderBlockOnInventory(tessellator, metadata, brightness, alpha);
+        super.renderBlockOnInventory(tessellator, metadata, brightness, alpha, lightmapCoordinate);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesOverlay.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesOverlay.java
index f09d8063e..6e13d8f7e 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesOverlay.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelLeavesOverlay.java
@@ -4,6 +4,7 @@ import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.client.render.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
 public class BlockModelLeavesOverlay<T extends Block> extends BlockModelLeaves<T> {
@@ -24,8 +25,8 @@ public class BlockModelLeavesOverlay<T extends Block> extends BlockModelLeaves<T
         return true;
     }
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha) {
-        super.renderBlockOnInventory(tessellator, metadata, brightness, alpha);
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+        super.renderBlockOnInventory(tessellator, metadata, brightness, alpha, lightmapCoordinate);
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
 
         IconCoordinate overlayCoord = overlayTexture;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelMossyStone.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelMossyStone.java
index 6f847043b..055ae05f5 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelMossyStone.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelMossyStone.java
@@ -5,6 +5,7 @@ import net.minecraft.client.render.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.core.block.Block;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
 public class BlockModelMossyStone<T extends Block> extends BlockModelStandard<T> {
@@ -25,9 +26,9 @@ public class BlockModelMossyStone<T extends Block> extends BlockModelStandard<T>
     }
 
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha) {
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         renderBlocks.useInventoryTint = false;
-        super.renderBlockOnInventory(tessellator, metadata, brightness, alpha);
+        super.renderBlockOnInventory(tessellator, metadata, brightness, alpha, lightmapCoordinate);
         renderBlocks.useInventoryTint = true;
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
index dc1e861c9..dff191a91 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
@@ -7,6 +7,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.logic.PistonDirections;
 import net.minecraft.core.block.piston.BlockPistonBase;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockModelPiston<T extends BlockPistonBase> extends BlockModelStandard<T> {
     private final IconCoordinate faceTexture;
@@ -125,8 +126,8 @@ public class BlockModelPiston<T extends BlockPistonBase> extends BlockModelStand
         return true;
     }
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha) {
-        super.renderBlockOnInventory(tessellator, 1, brightness, alpha);
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+        super.renderBlockOnInventory(tessellator, 1, brightness, alpha, lightmapCoordinate);
     }
     public IconCoordinate getFaceTexture()
     {
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelRedstoneWire.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelRedstoneWire.java
index 1629d22ae..8158b9bfb 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelRedstoneWire.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelRedstoneWire.java
@@ -7,6 +7,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockRedstoneWire;
+import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Color;
 
 public class BlockModelRedstoneWire<T extends Block> extends BlockModelStandard<T>{
@@ -27,16 +28,18 @@ public class BlockModelRedstoneWire<T extends Block> extends BlockModelStandard<
         }
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
-            int lmc = block.getLightmapCoord(renderBlocks.blockAccess, x, y, z);
-            if(Block.lightEmission[block.id] > 0) {
-                lmc = LightmapHelper.setBlocklightValue(lmc, 15);
-            }
+//            int lmc = block.getLightmapCoord(renderBlocks.blockAccess, x, y, z);
+//            if(Block.lightEmission[block.id] > 0) {
+//                lmc = LightmapHelper.setBlocklightValue(lmc, 15);
+//            }
+            int lmc = LightmapHelper.getLightmapCoord(renderBlocks.blockAccess.getSavedLightValue(LightLayer.Sky, x, y, z), Math.max(renderBlocks.blockAccess.getSavedLightValue(LightLayer.Block, x, y, z), meta & 0xF));
             tessellator.setLightmapCoord(lmc);
         }else {
             brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
             if(Block.lightEmission[block.id] > 0) {
                 brightness = 1.0f;
             }
+            brightness = Math.max(brightness, (meta & 0xF)/16f);
         }
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
index 238cb4581..961c61704 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
@@ -41,6 +41,7 @@ public class BlockModelRepeater extends BlockModelStandard<BlockRedstoneRepeater
 
         int j1 = (meta & 0xc) >> 2;
         renderStandardBlock(tessellator, block, x, y, z);
+        resetRenderBlocks();
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
         	int lmc = block.getLightmapCoord(renderBlocks.blockAccess, x, y, z);
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
index cd7ed3bd2..ad79f2713 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
@@ -7,6 +7,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockStairs;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
 public class BlockModelStairs<T extends BlockStairs> extends BlockModelStandard<T> {
@@ -55,7 +56,7 @@ public class BlockModelStairs<T extends BlockStairs> extends BlockModelStandard<
     }
 
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha) {
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         if(renderBlocks.useInventoryTint)
         {
             int j = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
index eb14593e3..d55d6fa2f 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
@@ -1,13 +1,14 @@
 package net.minecraft.client.render.block.model;
 
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.client.render.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
 public class BlockModelStandard<T extends Block> extends BlockModel<T>{
@@ -28,7 +29,7 @@ public class BlockModelStandard<T extends Block> extends BlockModel<T>{
     }
 
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha) {
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         if(renderBlocks.useInventoryTint)
         {
             int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
@@ -40,36 +41,54 @@ public class BlockModelStandard<T extends Block> extends BlockModel<T>{
             GL11.glColor4f(brightness, brightness, brightness, alpha);
         }
         float yOffset = 0.5F;
-        
+
         setBlockBoundsForItemRender();
         GL11.glTranslatef(-0.5F, 0.0F - yOffset, -0.5F);
 
         tessellator.startDrawingQuads();
+        if (LightmapHelper.isLightmapEnabled() && lightmapCoordinate != null){
+            tessellator.setLightmapCoord(lightmapCoordinate);
+        }
         tessellator.setNormal(0.0F, -1F, 0.0F);
         renderBottomFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata));
         tessellator.draw();
 
         tessellator.startDrawingQuads();
+        if (LightmapHelper.isLightmapEnabled() && lightmapCoordinate != null){
+            tessellator.setLightmapCoord(lightmapCoordinate);
+        }
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
         renderTopFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.TOP, metadata));
         tessellator.draw();
 
         tessellator.startDrawingQuads();
+        if (LightmapHelper.isLightmapEnabled() && lightmapCoordinate != null){
+            tessellator.setLightmapCoord(lightmapCoordinate);
+        }
         tessellator.setNormal(0.0F, 0.0F, -1F);
         renderNorthFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
         tessellator.draw();
 
         tessellator.startDrawingQuads();
+        if (LightmapHelper.isLightmapEnabled() && lightmapCoordinate != null){
+            tessellator.setLightmapCoord(lightmapCoordinate);
+        }
         tessellator.setNormal(0.0F, 0.0F, 1.0F);
         renderSouthFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
         tessellator.draw();
 
         tessellator.startDrawingQuads();
+        if (LightmapHelper.isLightmapEnabled() && lightmapCoordinate != null){
+            tessellator.setLightmapCoord(lightmapCoordinate);
+        }
         tessellator.setNormal(-1F, 0.0F, 0.0F);
         renderWestFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
         tessellator.draw();
 
         tessellator.startDrawingQuads();
+        if (LightmapHelper.isLightmapEnabled() && lightmapCoordinate != null){
+            tessellator.setLightmapCoord(lightmapCoordinate);
+        }
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
         renderEastFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
         tessellator.draw();
@@ -87,32 +106,55 @@ public class BlockModelStandard<T extends Block> extends BlockModel<T>{
                 GL11.glColor4f(brightness, brightness, brightness, alpha);
             }
 
+            int overbrightLMC = 0;
+            if (LightmapHelper.isLightmapEnabled()){
+                overbrightLMC = LightmapHelper.getLightmapCoord(15, 15);
+            }
+
             tessellator.startDrawingQuads();
+            if (LightmapHelper.isLightmapEnabled()){
+                tessellator.setLightmapCoord(overbrightLMC);
+            }
             tessellator.setNormal(0.0F, -1F, 0.0F);
             renderBottomFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockOverbrightTextureFromSideAndMeta(Side.BOTTOM, metadata));
             tessellator.draw();
 
             tessellator.startDrawingQuads();
+            if (LightmapHelper.isLightmapEnabled()){
+                tessellator.setLightmapCoord(overbrightLMC);
+            }
             tessellator.setNormal(0.0F, 1.0F, 0.0F);
             renderTopFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockOverbrightTextureFromSideAndMeta(Side.TOP, metadata));
             tessellator.draw();
 
             tessellator.startDrawingQuads();
+            if (LightmapHelper.isLightmapEnabled()){
+                tessellator.setLightmapCoord(overbrightLMC);
+            }
             tessellator.setNormal(0.0F, 0.0F, -1F);
             renderNorthFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockOverbrightTextureFromSideAndMeta(Side.NORTH, metadata));
             tessellator.draw();
 
             tessellator.startDrawingQuads();
+            if (LightmapHelper.isLightmapEnabled()){
+                tessellator.setLightmapCoord(overbrightLMC);
+            }
             tessellator.setNormal(0.0F, 0.0F, 1.0F);
             renderSouthFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockOverbrightTextureFromSideAndMeta(Side.SOUTH, metadata));
             tessellator.draw();
 
             tessellator.startDrawingQuads();
+            if (LightmapHelper.isLightmapEnabled()){
+                tessellator.setLightmapCoord(overbrightLMC);
+            }
             tessellator.setNormal(-1F, 0.0F, 0.0F);
             renderWestFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockOverbrightTextureFromSideAndMeta(Side.WEST, metadata));
             tessellator.draw();
 
             tessellator.startDrawingQuads();
+            if (LightmapHelper.isLightmapEnabled()){
+                tessellator.setLightmapCoord(overbrightLMC);
+            }
             tessellator.setNormal(1.0F, 0.0F, 0.0F);
             renderEastFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockOverbrightTextureFromSideAndMeta(Side.EAST, metadata));
             tessellator.draw();
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
index 882e13fda..915854edd 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
@@ -7,6 +7,7 @@ import net.minecraft.core.block.BlockTrapDoor;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Sides;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
 public class BlockModelTrapDoor<T extends Block> extends BlockModelStandard<T> {
@@ -66,9 +67,9 @@ public class BlockModelTrapDoor<T extends Block> extends BlockModelStandard<T> {
         return true;
     }
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha) {
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         GL11.glTranslatef(0, 0.25f, 0);
-        super.renderBlockOnInventory(tessellator, metadata, brightness, alpha);
+        super.renderBlockOnInventory(tessellator, metadata, brightness, alpha, lightmapCoordinate);
     }
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
diff --git a/src/main/java/net/minecraft/client/render/entity/ItemEntityRenderer.java b/src/main/java/net/minecraft/client/render/entity/ItemEntityRenderer.java
index db48e8bd4..fc9f9db3f 100644
--- a/src/main/java/net/minecraft/client/render/entity/ItemEntityRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/ItemEntityRenderer.java
@@ -76,8 +76,10 @@ public class ItemEntityRenderer extends EntityRenderer<EntityItem>
 		}
 		GL11.glTranslatef((float) x, (float) y + bobbingOffset, (float) z);
 		GL11.glEnable(32826 /*GL_RESCALE_NORMAL_EXT*/);
+		GL11.glEnable(GL11.GL_BLEND);
 		BlockModel.setRenderBlocks(renderBlocks);
 		ItemModelDispatcher.getInstance().getDispatch(item).renderAsItemEntity(Tessellator.instance, entity, random, itemstack, renderCount, f3, brightness, partialTick);
+		GL11.glDisable(GL11.GL_BLEND);
 		GL11.glDisable(32826 /*GL_RESCALE_NORMAL_EXT*/);
 		GL11.glPopMatrix();
 	}
diff --git a/src/main/java/net/minecraft/client/render/entity/MinecartRenderer.java b/src/main/java/net/minecraft/client/render/entity/MinecartRenderer.java
index 44245ffee..1e97d4b8f 100644
--- a/src/main/java/net/minecraft/client/render/entity/MinecartRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/MinecartRenderer.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.model.ModelBase;
@@ -93,17 +92,17 @@ public class MinecartRenderer extends EntityRenderer<EntityMinecart>
             }
             if(minecart.minecartType == 1)
             {
-                BlockModelDispatcher.getInstance().getDispatch(Block.chestPlanksOak).renderBlockOnInventory(tessellator, 0, brightness);
+                BlockModelDispatcher.getInstance().getDispatch(Block.chestPlanksOak).renderBlockOnInventory(tessellator, 0, brightness, null);
             } else
             if(minecart.minecartType == 2)
             {
                 if (minecart.fuel > 0)
                 {
-                    BlockModelDispatcher.getInstance().getDispatch(Block.furnaceStoneActive).renderBlockOnInventory(tessellator, 0, brightness);
+                    BlockModelDispatcher.getInstance().getDispatch(Block.furnaceStoneActive).renderBlockOnInventory(tessellator, 0, brightness, null);
                 }
                 else
                 {
-                    BlockModelDispatcher.getInstance().getDispatch(Block.furnaceStoneIdle).renderBlockOnInventory(tessellator, 0, brightness);
+                    BlockModelDispatcher.getInstance().getDispatch(Block.furnaceStoneIdle).renderBlockOnInventory(tessellator, 0, brightness, null);
                 }
             }
             GL11.glRotatef(-90F, 0.0F, 1.0F, 0.0F);
diff --git a/src/main/java/net/minecraft/client/render/entity/MobRenderer.java b/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
index e597567db..160f35626 100644
--- a/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.render.entity;
 
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.model.ModelBiped;
 import net.minecraft.client.render.tessellator.Tessellator;
